===================================================================
--- src/apps/aboutsystem/AboutSystem.cpp        (revision 24890)
+++ src/apps/aboutsystem/AboutSystem.cpp        (working copy)
@@ -492,15 +492,33 @@
        fCreditsView->Insert("\nCopyrights\n\n");
 
        // GNU copyrights
-       AddCopyrightEntry("The GNU Project", 
+       AddCopyrightEntry("The GNU Project",
                "Contains software from the GNU Project, "
                "released under the GPL and LGPL licences:\n"
-               "       - GNU C Library,\n"
-               "       - GNU coretools, diffutils, findutils, gawk, bison, m4, make,\n"
-               "       - Bourne Again Shell.\n"
-               "Copyright " B_UTF8_COPYRIGHT " The Free Software Foundation.", 
+               "GNU C Library, "
+               "GNU coretools, diffutils, findutils, "
+               "gawk, bison, m4, make, "
+               "gdb, wget, ncurses, termcap, "
+               "Bourne Again Shell.\n"
+               "Copyright " B_UTF8_COPYRIGHT " The Free Software Foundation.",
                "www.gnu.org");
 
+       // FreeBSD copyrights
+       AddCopyrightEntry("The FreeBSD Project",
+               "Contains software from the FreeBSD Project, "
+               "released under the BSD licence:\n"
+               "ping, telnet, telnetd, traceroute\n"
+               "Copyright " B_UTF8_COPYRIGHT " 1994-2008 The FreeBSD Project.  All rights reserved.",
+               "www.freebsd.org");
+
+       // NetBSD copyrights
+       AddCopyrightEntry("The NetBSD Project",
+               "Contains software developed by the NetBSD, "
+               "Foundation, Inc. and its contributors:\n"
+               "ftp\n"
+               "Copyright " B_UTF8_COPYRIGHT " 1996-2008 The NetBSD Foundation, Inc.  All rights reserved.",
+               "www.netbsd.org");
+
        // FFMpeg copyrights
        AddCopyrightEntry("FFMpeg libavcodec", 
                "Copyright " B_UTF8_COPYRIGHT " 2000-2007 Fabrice Bellard, et al.", 
@@ -515,7 +533,7 @@
        AddCopyrightEntry("PDFLib", 
                "Copyright " B_UTF8_COPYRIGHT " 1997-2006 PDFlib GmbH and Thomas Merz. "
                "All rights reserved.\n"
-               "PDFlib and the PDFlib logo are registered trademarks of PDFlib GmbH.", 
+               "PDFlib and PDFlib logo are registered trademarks of PDFlib GmbH.", 
                "www.pdflib.com");
 
        // FreeType copyrights
@@ -582,13 +600,67 @@
 
        // OpenEXR copyrights
        AddCopyrightEntry("OpenEXR", 
-               "Copyright " B_UTF8_COPYRIGHT " 2002-2005, Industrial Light & Magic, a division of Lucas Digital Ltd. LLC.");
+               "Copyright " B_UTF8_COPYRIGHT " 2002-2005 Industrial Light & Magic, a division of Lucas Digital Ltd. LLC.");
                
        // Bullet copyrights
        AddCopyrightEntry("Bullet", 
                "Copyright " B_UTF8_COPYRIGHT " 2003-2008 Erwin Coumans",
                "www.bulletphysics.com");
+               
+       // atftp copyrights
+       AddCopyrightEntry("atftp",
+               "Copyright " B_UTF8_COPYRIGHT " 2000 Jean-Pierre Lefebvre and Remi Lefebvre");
 
+       // Netcat copyrights
+       AddCopyrightEntry("Netcat",
+               "Copyright " B_UTF8_COPYRIGHT " 1996 Hobbit");
+
+       // acpica copyrights
+       AddCopyrightEntry("acpica",
+               "Copyright " B_UTF8_COPYRIGHT " 1999 - 2006 Intel Corp.");
+
+       // unrar copyrights
+       AddCopyrightEntry("unrar",
+               "Copyright " B_UTF8_COPYRIGHT " Alexander L. Roshal.");
+
+       // libpng copyrights
+       AddCopyrightEntry("libpng",
+               "Copyright " B_UTF8_COPYRIGHT " 2004, 2006-2008 Glenn Randers-Pehrson.");
+
+       // libprint copyrights
+       AddCopyrightEntry("libprint",
+               "Copyright " B_UTF8_COPYRIGHT " 1999-2000 Y.Takagi. All Rights Reserved.");
+
+       // cortex copyrights
+       AddCopyrightEntry("Cortex",
+               "Copyright " B_UTF8_COPYRIGHT " 1999-2000 Eric Moon.");
+
+       // FluidSynth copyrights
+       AddCopyrightEntry("FluidSynth",
+               "Copyright " B_UTF8_COPYRIGHT " 2003 Peter Hanappe and others.");
+
+       // CannaIM copyrights
+       AddCopyrightEntry("CannaIM",
+               "Copyright " B_UTF8_COPYRIGHT " 1999 Masao Kawamura.");
+
+       // libxml2, libxslt, libexslt copyrights
+       AddCopyrightEntry("libxml2, libxslt",
+               "Copyright " B_UTF8_COPYRIGHT " 1998-2003 Daniel Veillard.  All Rights Reserved.");
+
+       AddCopyrightEntry("libexslt",
+               "Copyright " B_UTF8_COPYRIGHT " 2001-2002 Thomas Broyer, Charlie Bozeman and Daniel Veillard.  All Rights Reserved.");
+
+       // Xiph.org Foundation copyrights
+       AddCopyrightEntry("Xiph.org Foundation",
+               "libvorbis, libogg, libtheora, libspeex"
+               "Copyright " B_UTF8_COPYRIGHT " 1994-2008 Xiph.Org.  All rights reserved.",
+               "www.xiph.org");
+
+       // The Tcpdump Group
+       AddCopyrightEntry("The Tcpdump Group",
+               "tcpdump, libpcap",
+               "www.tcpdump.org");             
+
        // Build a list of installed applications and show their 
        // long version info. Well-behaved apps usually give
        // copyright info there.